/*
 * Copyright (c) 1992 Kent State University.
 * All rights reserved.  The Kent State University 
 * software License Agreement specifies the terms and conditions 
 * for redistribution.
 *
 *	@(#)xcommf1.c	1.1 (Kent State) 2/28/92
 *
 *	Author: Paul B. Ricks
 *
 *	The spirit of the Gnu Licensing Agreement Applies to this software and 
 *	Kent State University should be substituted where ever Gnu appears.
 *
 */

#ifndef lint
static char copyright[] =
"@(#) Copyright (c) 1992 Kent State University.\n\
 All rights reserved.\n";
#endif /* not lint */

#ifndef lint
static char sccsid[] = "@(#)xcommf1.c 1.1 (Kent State Univ.) 2/28/92";
#endif /* not lint */

/*

                            NO WARRANTY

   BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
REPAIR OR CORRECTION.

  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.

                     END OF TERMS AND CONDITIONS
*/

/*
 * xcommf1.c contains routines to handle xcomm options, recording/playing messages and
 * putting/taking calls on/off the call menu. It also contain a few signal handlers that
 * don't do anything.
 */

static char *author = " By Paul B. Ricks @ Kent State Univ. (3/21/92) -- ricks@mcs.kent.edu ";

#include	"xcommon.h"


#define BACKWARD	3
#define FORWARD		4
#define DONT_MOVE	5
#define	Little_BufSize	10
#define	MAX_BUFSIZE	80
#define	LEAVE_MSG	0
#define	READ_MSG	1

onholdRec calls[MAX_QUE_CALLS];

extern char MESSAGE_IN[];
extern char MESSAGE_OUT[];

int msgtype;
int ifd, ofd;
int clearflag;
Bool noOptions = False;
Bool ismsgBoxUp = False;
int newMessages = 0;
int messageInCounter, messageOutCounter;
int currentIncounter, currentOutcounter;
Bool messageOutActive = False;
int smglen = sizeof(MESSAGE_REC);

static struct _msgfile {		/* message file structure */
	int numMsg;			/* # of messages currently in file */
	int currentMsgNum;		/* current message Number */
	long currentFilePos;		/* current file pointer */
	int fd;	
} msgfileInfo[2];			/* in-coming and out-going messages */

void PopdownHLog(), PopupHLog();
void SetBellFlag(), ClearMsg(), SaveMsg(), DeleteMsg(), PrevMsg(), NextMsg();
void SetAutoanswerFlag(), SetPhonelineFlag(), SetReadMsgCommands(), SetLeaveMsgCommands();
void PopupMessages(), PopdownMessages(), PopdownOptions(), PopupOptions(), hangUp(), Pick_call();
void popupLogger(), popupOptions();

extern int childpid;
Widget nextmsg_w, msgcounter_w, leavemsg_w, readmsg_w, savemsg_w, newmsg_w, username_w, msg_w;
extern Bool noOptions, validMessages;
extern int callwaiting; 
extern Bool oldAAnswerstate, newAAnswerstate, oldPhonestate, newPhonestate, msgAnnouncer;
extern Widget message_w, options_w, status_w, pickcall_w, hangup_w, callmenu_w, typing_w;
extern Widget retrievemsg_w, accept_w;
extern char hisNameBuf[], hisAddressBuf[];
extern errorRec gerrordata;


Widget  create_optionpanel(toplevel)
	Widget	toplevel;
{
	Widget p;
	String lbuf;
	XtTranslations trans;
	Widget f, f2, a1, b1, a2, b2, l1, l2;
    

    	p = XtVaCreatePopupShell(" XComm Options ", transientShellWidgetClass, toplevel, 
				   XtNresizable, False,
				   NULL);

		            
        f = XtVaCreateManagedWidget("oform", formWidgetClass, p, XtNdefaultDistance, 2,
				    XtNresizable, False,
				    NULL);

        f2 = XtVaCreateManagedWidget("oform1", formWidgetClass, f, XtNdefaultDistance, 2,
				    XtNresizable, False,
				    NULL);


        l1 = XtVaCreateManagedWidget("oPhonelineL", labelWidgetClass, f2,
				    XtNresizable, False,
				    XtNfromHoriz, NULL, 
				    XtNfromVert, NULL, 
				    NULL);

    	a1 = XtVaCreateManagedWidget("oPhone", toggleWidgetClass, f2,
				     XtNfromHoriz, l1,
				     XtNstate, True,
				     XtNfromVert, NULL,
				     XtNresizable, False,
				     NULL);
	XtAddCallback(a1, XtNcallback, SetPhonelineFlag, NULL);


        l2 = XtVaCreateManagedWidget("oAnswermachineL", labelWidgetClass, f2,
				    XtNfromVert, NULL, 
				    XtNfromHoriz, a1, 
				    XtNresizable, False,
				    NULL);

    	a2 = XtVaCreateManagedWidget("oAnswermachine", toggleWidgetClass, f2,
				     XtNfromHoriz, l2,
				     XtNstate, False,
				     XtNfromVert, NULL,
				     XtNresizable, False,
				     NULL);
	XtAddCallback(a2, XtNcallback, SetAutoanswerFlag, NULL);

        l2 = XtVaCreateManagedWidget("oBellL", labelWidgetClass, f2,
				    XtNfromVert, NULL, 
				    XtNfromHoriz, a2, 
				    XtNresizable, False,
				    NULL);

    	b2 = XtVaCreateManagedWidget("oBell", toggleWidgetClass, f2,
				     XtNfromHoriz, l2,
				     XtNstate, True,
				     XtNfromVert, NULL,
				     XtNresizable, False,
				     NULL);
	XtAddCallback(b2, XtNcallback, SetBellFlag, NULL);

    	a2 = XtVaCreateManagedWidget("oQuit", commandWidgetClass, f2,
				     XtNfromHoriz, b2,
				     XtNfromVert, NULL,
				     XtNresizable, False,
				     NULL);
	XtAddCallback(a2, XtNcallback, PopdownOptions, NULL);

        l2 = XtVaCreateManagedWidget("oAuthL", labelWidgetClass, f,
				    XtNfromVert, f2, 
				    XtNfromHoriz, NULL, 
				    XtNresizable, False,
				    XtNlabel, author,
				    XtNvertDistance, 5,
				    NULL);
    	return (p);
}	



Widget  create_msgpanel(toplevel)
	Widget	toplevel;
{
	Widget p;
	String lbuf;
	XtTranslations trans;
    	Widget f, t1, t2, f2, f3, f4, a, b, l;
    

    	p = XtVaCreatePopupShell("Messages",  transientShellWidgetClass, toplevel, NULL);
		            
        f = XtVaCreateManagedWidget("mform", formWidgetClass, p, XtNdefaultDistance, 2,
				    NULL);

        f2 = XtVaCreateManagedWidget("mform0", formWidgetClass, f,
				     XtNfromVert, NULL,
				     XtNfromHoriz, NULL, 
				     XtNresizable, TRUE,
				     XtNdefaultDistance, 1,
				     NULL);

        l = XtVaCreateManagedWidget("mLabel", labelWidgetClass, f2,
				    XtNresizable, TRUE,
				    XtNfromHoriz, NULL, 
				    XtNfromVert, NULL, 
				    NULL);

        a = XtVaCreateManagedWidget("mInputLine", asciiTextWidgetClass, f2,
				    XtNresizable, TRUE,
				    XtNfromVert, NULL,
				    XtNfromHoriz, l,
				    XtNtype, XawAsciiString,
				    XtNlength, MAX_BUFSIZE, 
				    XtNeditType, XawtextEdit, 
				    XtNscrollVertical, XawtextScrollNever,
				    XtNscrollHorizontal, XawtextScrollNever,
				    NULL);
	username_w = a;
        msgcounter_w = XtVaCreateManagedWidget("mCounter", labelWidgetClass, f2,
				    XtNresizable, TRUE,
				    XtNfromHoriz, a, 
				    XtNfromVert, NULL, 
				    NULL);


        f3 = XtVaCreateManagedWidget("mform1", formWidgetClass, f,
				     XtNfromVert, f2,
				     XtNfromHoriz, NULL, 
				     XtNresizable, TRUE,
				     XtNdefaultDistance, 1,
				     NULL);

        a = XtVaCreateManagedWidget("mWindow", asciiTextWidgetClass, f3,
				    XtNresizable, TRUE,
				    XtNfromVert, NULL,
				    XtNfromHoriz, NULL,
				    XtNtype, XawAsciiString,
				    XtNlength, MESSAGE_LENGTH, 
				    XtNeditType, XawtextEdit, 
				    XtNscrollVertical, XawtextScrollAlways,
				    XtNscrollHorizontal, XawtextScrollNever,
				    NULL);
	msg_w = a;

        f4 = XtVaCreateManagedWidget("mform2", formWidgetClass, f,
				     XtNfromVert, f3,
				     XtNfromHoriz, NULL, 
				     XtNresizable, TRUE,
				     XtNdefaultDistance, 1,
				     NULL);


    	b = XtVaCreateManagedWidget("mSave", commandWidgetClass, f4,
				     XtNfromHoriz, NULL,
				     XtNfromVert, NULL,
				     XtNresizable, TRUE,
				     NULL);
	XtAddCallback(b, XtNcallback, SaveMsg, NULL);
	savemsg_w = b;

    	a = XtVaCreateManagedWidget("mDelete", commandWidgetClass, f4,
				     XtNfromHoriz, b,
				     XtNfromVert, NULL,
				     XtNresizable, TRUE,
				     NULL);
	XtAddCallback(a, XtNcallback, DeleteMsg, NULL);

    	b = XtVaCreateManagedWidget("mClear", commandWidgetClass, f4,
				     XtNfromHoriz, a,
				     XtNfromVert, NULL,
				     XtNresizable, TRUE,
				     NULL);
	newmsg_w = b;
	XtAddCallback(b, XtNcallback, ClearMsg , NULL);

    	a = XtVaCreateManagedWidget("mNext", commandWidgetClass, f4,
				     XtNfromHoriz, b,
				     XtNfromVert, NULL,
				     XtNresizable, TRUE,
				     NULL);
	XtAddCallback(a, XtNcallback, NextMsg, NULL);
	nextmsg_w = a;

    	b = XtVaCreateManagedWidget("mPrevious", commandWidgetClass, f4,
				     XtNfromHoriz, a,
				     XtNfromVert, NULL,
				     XtNresizable, TRUE,
				     NULL);
	XtAddCallback(b, XtNcallback, PrevMsg, NULL);

    	t1 = XtVaCreateManagedWidget("mReadMsg", toggleWidgetClass, f4,
				     XtNfromHoriz, b,
				     XtNstate, False,
				     XtNfromVert, NULL,
				     XtNresizable, True,
				     XtNradioData, 1,
				     NULL);
	XtAddCallback(t1, XtNcallback, SetReadMsgCommands, NULL);
	readmsg_w = t1;

    	t2 = XtVaCreateManagedWidget("mLeaveMsg", toggleWidgetClass, f4,
				     XtNfromHoriz, t1,
				     XtNstate, True,
				     XtNfromVert, NULL,
				     XtNresizable, TRUE,
				     XtNradioGroup, t1, 
				     XtNradioData, 2,
				     NULL);
	XtAddCallback(t2, XtNcallback, SetLeaveMsgCommands, NULL);
	leavemsg_w = t2;

    	a = XtVaCreateManagedWidget("mQuit", commandWidgetClass, f4,
				     XtNfromHoriz, leavemsg_w,
				     XtNfromVert, NULL,
				     XtNresizable, TRUE,
				     NULL);
	XtAddCallback(a, XtNcallback, PopdownMessages, NULL);


    	return (p);
}	

void	updateCounterDisplay()
{
	char buf[10];

	if (msgfileInfo[msgtype].numMsg > 0 && msgfileInfo[msgtype].currentMsgNum <= 0)
	    msgfileInfo[msgtype].currentMsgNum = 1;
	sprintf(buf, "%02d of %02d ", msgfileInfo[msgtype].currentMsgNum, msgfileInfo[msgtype].numMsg);
	XtVaSetValues(msgcounter_w, XtNlabel, 
		      buf,
		      NULL);
}

/*ARGSUSED*/
void	SetReadMsgCommands(w, client_data, call_data)
	Widget w;
	XtPointer client_data;
	XtPointer call_data;
{
	if (messageOutActive) {
	    messageOutActive = False;
	    msgtype = READ_MSG;
	    XtSetSensitive(msg_w, False);
	    XtSetSensitive(username_w, False);
	    XtSetSensitive(newmsg_w, False);
	    XtSetSensitive(savemsg_w, False);
	    XtCallCallbacks(newmsg_w, "callback", NULL);
	    clearflag = 0;
	    XtVaSetValues(username_w, XtNdisplayCaret, False, NULL);
	    XtVaSetValues(msg_w, XtNdisplayCaret, False, NULL);
	    if (msgfileInfo[msgtype].fd > 0)
	        displayAnotherMsg(DONT_MOVE);
	    updateCounterDisplay();
	}
}

/*ARGSUSED*/
void	SetLeaveMsgCommands(w, client_data, call_data)
	Widget w;
	XtPointer client_data;
	XtPointer call_data;
{
	if (!messageOutActive) {
	    msgtype = LEAVE_MSG;
	    messageOutActive = True;
	    XtSetSensitive(msg_w, True);
	    XtSetSensitive(username_w, True);
	    XtSetSensitive(newmsg_w, True);
	    XtSetSensitive(savemsg_w, True);
	    XtCallCallbacks(newmsg_w, "callback", NULL);
	    clearflag = 0;
	    XtVaSetValues(username_w, XtNdisplayCaret, True, NULL);
	    XtVaSetValues(msg_w, XtNdisplayCaret, True, NULL);
	    if (msgfileInfo[msgtype].fd > 0)
	        displayAnotherMsg(DONT_MOVE);
	    updateCounterDisplay();
	}
}

/*ARGSUSED*/
void	SetAutoanswerFlag(w, client_data, call_data)
	Widget w;
	XtPointer client_data;
	XtPointer call_data;
{
	newAAnswerstate = newAAnswerstate ? False:True;
	XtVaSetValues(w, XtNlabel,
		      newAAnswerstate ? " On ":" Off",
		      NULL);
}

/*ARGSUSED*/
void	SetBellFlag(w, client_data, call_data)
	Widget w;
	XtPointer client_data;
	XtPointer call_data;
{
	extern Bool ringBell;

	ringBell = ringBell ? False:True;
	XtVaSetValues(w, XtNlabel,
		      ringBell ? " On ":" Off",
		      NULL);
}
/*ARGSUSED*/
void	SetPhonelineFlag(w, client_data, call_data)
	Widget w;
	XtPointer client_data;
	XtPointer call_data;
{
	newPhonestate = newPhonestate ? False:True;
	XtVaSetValues(w, XtNlabel,
		      newPhonestate ? " On ":" Off",
		      NULL);
}

/*ARGSUSED*/
void	PopdownMessages(w, client_data, call_data)
	Widget w;
	XtPointer client_data;
	XtPointer call_data;
{
	struct stat stbuf;

	if (msgfileInfo[LEAVE_MSG].fd > 0) close(msgfileInfo[LEAVE_MSG].fd);
	if (msgfileInfo[READ_MSG].fd > 0) close(msgfileInfo[READ_MSG].fd);

	if (!msgfileInfo[LEAVE_MSG].numMsg && !access(MESSAGE_OUT, F_OK)) 
	    unlink(MESSAGE_OUT);

	if (!msgfileInfo[READ_MSG].numMsg && !access(MESSAGE_IN, F_OK) && !newMessages) 
	    unlink(MESSAGE_IN);

	if (!msgfileInfo[READ_MSG].numMsg || newMessages)
	    XtVaSetValues(retrievemsg_w,
			  XtNlabel, " Record Msg",
			  NULL);

	if (newMessages) {
	    char buf[MAX_BUFSIZE];

	    sprintf(buf, "   You have new message%-c.", newMessages > 1 ? 's':' ');
	    issueError(buf, VVSHORT_REPEAT, FQ5_INDX, BELL_TONE5, 2);
	}
	ismsgBoxUp = False;
	newMessages = 0;
	XtSetSensitive(retrievemsg_w, True);
        XtPopdown(message_w);

}

/*ARGSUSED*/
void PopupMessages(w, client_data, call_data)
	Widget  w;
	XtPointer client_data; 
	XtPointer call_data;
{
	Position x, y;
	Dimension width, height;
	extern Widget topLevel;

	msgAnnouncer = False; 
	ismsgBoxUp = True;

	XtSetSensitive(retrievemsg_w, False);
	checkForMessages(1);
	msgfileInfo[LEAVE_MSG].fd = open(MESSAGE_OUT, (O_CREAT | O_RDWR), 0666);
	msgfileInfo[READ_MSG].fd = open(MESSAGE_IN, O_RDWR, 0666); 

	messageOutActive = False;
	XtVaGetValues(topLevel,		/* position message box close to main menu */
		       XtNx, &x,
		       XtNy, &y,
		       XtNwidth, &width,
		       XtNheight, &height,
		       NULL);

	XtVaSetValues(message_w, 
		       XtNx, x + 5,
		       XtNy, y + (height/3),
		       NULL);
	XtPopup(message_w, XtGrabNone);

	XawToggleUnsetCurrent(readmsg_w);
	if (msgfileInfo[READ_MSG].numMsg) {
	    XtVaSetValues(username_w, XtNdisplayCaret, False, NULL);
	    XtVaSetValues(readmsg_w, XtNdisplayCaret, False, NULL);
	    XawToggleSetCurrent(readmsg_w, 1);
	    msgtype = READ_MSG;
	}
	else {
	    msgtype = LEAVE_MSG;
	    messageOutActive = True;
	    XtVaSetValues(username_w, XtNdisplayCaret, True, NULL);
	    XtVaSetValues(readmsg_w, XtNdisplayCaret, True, NULL);
	    XawToggleSetCurrent(readmsg_w, 2);
	}
	XtCallCallbacks(newmsg_w, "callback", NULL);
	clearflag = 0;
	displayAnotherMsg(DONT_MOVE);
	if (msgfileInfo[msgtype].numMsg) 
	    msgfileInfo[msgtype].currentMsgNum = 1;
    	updateCounterDisplay();
}

/*ARGSUSED*/
void PopupHLog(w, event, params, nparams)
    	Widget w;
    	XEvent *event;
    	String *params;
    	Cardinal *nparams;
{
	popupLogger();
}
	
void	popupLogger()
{
	Position x, y;
	Dimension width, height, width2;

	extern Widget topLevel, hisLog_w, hisList_w, logQuit_w, logLabel_w;
	extern int logCounter;
	extern String hisLog[];

	if (!logCounter || noOptions) {
	    if (!noOptions)
	        issueError("  No caller so far.", VVSHORT_REPEAT, FQ5_INDX, BELL_TONE4, 0);
	    return;
	}
	XtVaGetValues(topLevel,
		      XtNx, &x,
		      XtNy, &y,
		      XtNwidth, &width,
		      XtNheight, &height,
		      NULL);

	XtVaSetValues(hisLog_w, 
		      XtNx, x + (width/2),
		      XtNy, y + (height/3),
		      NULL);

	XtVaGetValues(logQuit_w,
		      XtNwidth, &width,
		      NULL);

	XtVaGetValues(hisList_w,
		      XtNwidth, &width2,
		      NULL);

	XtVaSetValues(logLabel_w, 
		      XtNwidth, width2 - width - 8,
		      NULL);

	XtPopup(hisLog_w, XtGrabNone);
}

/*ARGSUSED*/
void PopdownHLog(w, client_data, call_data)
    	Widget w;
	XtPointer client_data; 
	XtPointer call_data;
{
	Widget tw = (Widget)client_data;

        XtPopdown(tw);

}

/*ARGSUSED*/
void PopupOptions(w, event, params, nparams)
    	Widget w;
    	XEvent *event;
    	String *params;
    	Cardinal *nparams;
{
	popupOptions();
}

void popupOptions()
{
	Position x, y;
	Dimension width, height;

	extern Widget topLevel;

	if (!noOptions) {
	    newAAnswerstate = oldAAnswerstate;
	    newPhonestate = oldPhonestate;
	    XtVaGetValues(topLevel,
		          XtNx, &x,
			  XtNy, &y,
			  XtNwidth, &width,
			  XtNheight, &height,
			  NULL);
	    XtVaSetValues(options_w, 
			  XtNx, x + 2,
			  XtNy, y + (height/3),
			  NULL);

	    XtPopup(options_w, XtGrabNonexclusive);
	    noOptions = True;
	}
	else
	    ring_bell(BELL_TONE4);
}

/*ARGSUSED*/
void PopdownOptions(w, client_data, call_data)
    	Widget w;
	XtPointer client_data; 
	XtPointer call_data;
{
	LOCAL_MSG lmsg;

	if (newPhonestate != oldPhonestate) {
	    xrelay_msg(&lmsg, PHONELINE);
	    oldPhonestate = newPhonestate;
	}
	if (newAAnswerstate != oldAAnswerstate) {
	    xrelay_msg(&lmsg, AUTO_ANSWER);
	    oldAAnswerstate = newAAnswerstate;
	    XtSetSensitive(retrievemsg_w, True);
	}
	noOptions = False;
        XtPopdown(options_w);

}


/*ARGSUSED*/
void SaveMsg(w, client_data, call_data)
    	Widget w;
	XtPointer client_data; 
	XtPointer call_data;
{
	Widget s;
	Bool error, updated;
	char *sp, *sp2;
	char buf[MAX_MSGBUF];
	int cread, i, n;
        XawTextBlock text;
	XawTextPosition ipos;
	MESSAGE_REC msg, msg2;
	int msglen = sizeof(MESSAGE_REC);


	error = True;
	text.firstPos = 0;
	text.length = 0;
	text.ptr = (char *)0;

        s = XawTextGetSource(username_w);
        cread = XawTextSourceRead(s, 0, &text, MAX_MSGBUF);

	if (cread > 0) {
	    text.ptr[cread] = '\0';
	    strcpy(buf, text.ptr);
	    sp = strtok(buf, " \t");
	    sp2 = strtok((char *)0, "\t ");
	    if (!sp2) {
	        memset((char *)&msg, '\0', msglen);
		strcpy(msg.u_name, sp);
		error = False;
	    }
	    else 
	        issueError("  ill-formed user name --- might have more than one user name !!!", VSHORT_REPEAT, FQ5_INDX, 
			   BELL_TONE4, 3);
		
	}
	if (!error) {
	    text.firstPos = 0;
	    text.length = 0;
	    text.ptr = (char *)0;
            s = XawTextGetSource(msg_w);
            cread = XawTextSourceRead(s, 0, &text, MESSAGE_LENGTH);
	    if (cread > 0) {
		strncpy(msg.line, text.ptr, cread);
		msg.status = VALID;
		updated = False;
		(void)lseek(msgfileInfo[msgtype].fd, 0L, L_SET);
		for (i = 0; read(msgfileInfo[msgtype].fd, (char *)&msg2, msglen) > 0; i++) {
		     if (msg2.status == NOT_VALID && !updated) {
			 if (lseek(msgfileInfo[msgtype].fd, (i * msglen), L_SET) >= 0) {
			     if (write(msgfileInfo[msgtype].fd, (char *)&msg, smglen) > 0) {
				 msgfileInfo[msgtype].currentFilePos = i;
			         error = False;
				 updated = True;
			         msgfileInfo[msgtype].numMsg++;
			         msgfileInfo[msgtype].currentMsgNum++;
				 sprintf(buf, "  Message for %-s recorded !!!", msg.u_name);
	        		 issueError(buf, VVSHORT_REPEAT, FQ3_INDX, BELL_TONE4, 0);
			     }
			 }
		     }
		     else if (msg2.status == VALID && !strcmp(msg.u_name, msg2.u_name)){
		         if (lseek(msgfileInfo[msgtype].fd, (i * msglen), L_SET) >= 0) {
			     if (!updated) {
			         if (write(msgfileInfo[msgtype].fd, (char *)&msg, smglen) > 0) {
				     msgfileInfo[msgtype].currentFilePos = i;
				     if (!updated) {
				         sprintf(buf, "  Old message for %-s overwritten !!!", msg.u_name);
	        		         issueError(buf, VVSHORT_REPEAT, FQ5_INDX, BELL_TONE4, 0);
				     }
			   	     updated = True;
				     error = False;
				 }
			     }
			     else {
			         msg2.status = NOT_VALID;
			         if (lseek(msgfileInfo[msgtype].fd, (i * msglen), L_SET) >= 0) {
				     msgfileInfo[msgtype].numMsg--;
			             msgfileInfo[msgtype].currentMsgNum--;
				     if (write(msgfileInfo[msgtype].fd, (char *)&msg2, smglen) <= 0)
				         error = True;
				 }
			     }
		         }
		     }
		}
	        if (!updated && !error)
		    if (lseek(msgfileInfo[msgtype].fd, (i * smglen), L_SET) >= 0) {
	                write(msgfileInfo[msgtype].fd, (char *)&msg, smglen);
			msgfileInfo[msgtype].currentFilePos = i;
			msgfileInfo[msgtype].numMsg++;
			msgfileInfo[msgtype].currentMsgNum++;
			lseek(msgfileInfo[msgtype].fd, (i * smglen), L_SET);
			sprintf(buf, "  Message for %-s saved !!!", msg.u_name);
	        	issueError(buf, VVSHORT_REPEAT, FQ5_INDX, BELL_TONE4, 0);
		    }
		updateCounterDisplay();
	    }
	    else
	        issueError("  Null message body --- message not recorded !!!", VSHORT_REPEAT, FQ6_INDX, 
			    BELL_TONE4, 2);
	}
}


/*ARGSUSED*/
void DeleteMsg(w, client_data, call_data)
    	Widget w;
	XtPointer client_data; 
	XtPointer call_data;
{
	MESSAGE_REC msg;

	if (msgfileInfo[msgtype].fd <= 0 || msgfileInfo[msgtype].numMsg <= 0) {
	    issueError("  No more messages to delete !!!", VVSHORT_REPEAT, FQ5_INDX, 
			    BELL_TONE4, 2);
	    return;
	}

	if (lseek(msgfileInfo[msgtype].fd, (msgfileInfo[msgtype].currentFilePos * smglen), L_SET) >= 0) {
	   read(msgfileInfo[msgtype].fd, (char *)&msg, sizeof(msg));
	   lseek(msgfileInfo[msgtype].fd, (msgfileInfo[msgtype].currentFilePos * smglen), L_SET); 
	   if (msg.status == VALID) {
	       msg.status = NOT_VALID;
	       if (write(msgfileInfo[msgtype].fd, (char *)&msg, smglen) > 0) {

		   msgfileInfo[msgtype].numMsg--;

		   if (displayAnotherMsg(FORWARD) < 0) { 
		       if (displayAnotherMsg(BACKWARD) < 0)
			   XtCallCallbacks(newmsg_w, "callback", NULL);
		       msgfileInfo[msgtype].currentMsgNum--;
		   }
		   if (msgfileInfo[msgtype].numMsg <= 0) {
		       msgfileInfo[msgtype].currentFilePos = 0;
		       msgfileInfo[msgtype].numMsg = msgfileInfo[msgtype].currentMsgNum = 0;
		       if (msgtype == READ_MSG) {
			   XtVaSetValues(username_w, XtNdisplayCaret, True, NULL);
			   XtVaSetValues(readmsg_w, XtNdisplayCaret, True, NULL);
			   XawToggleSetCurrent(readmsg_w, 2);
			   XtCallCallbacks(leavemsg_w, "callback", NULL);
		       }
		   }
		   updateCounterDisplay();
	       }
	  }
	}
}

/*ARGSUSED*/
void ClearMsg(w, client_data, call_data)
    	Widget w;
	XtPointer client_data; 
	XtPointer call_data;
{
	XawTextBlock text;

	text.firstPos = 0;
	text.length = 0;
	text.ptr = (char *)0;

	clearflag = 1;
	(void)XawTextReplace(msg_w, 0, MESSAGE_LENGTH , &text);
	XawTextSetInsertionPoint(msg_w, 0);
	(void)XawTextReplace(username_w, 0, MAX_MSGBUF , &text);
	XawTextSetInsertionPoint(username_w, 0);

}

/*ARGSUSED*/
void NextMsg(w, client_data, call_data)
    	Widget w;
	XtPointer client_data; 
	XtPointer call_data;
{
	if (clearflag) {
	    if (displayAnotherMsg(DONT_MOVE) < 0)
		issueError("  No more messages !!!", VVSHORT_REPEAT, FQ5_INDX, BELL_TONE4, 1);
	    clearflag = 0;
	    return;
	}

	if (!msgfileInfo[msgtype].numMsg) {
	    issueError("  There are no messages !!!", VVSHORT_REPEAT, FQ5_INDX, BELL_TONE4, 1);
	    return;
	}

	if (msgfileInfo[msgtype].fd <= 0 || 
	    msgfileInfo[msgtype].currentMsgNum == msgfileInfo[msgtype].numMsg) {
	    issueError("  This is the last message !!!", VVSHORT_REPEAT, FQ5_INDX, 
			    BELL_TONE4, 2);
	    return;
	}
	if (displayAnotherMsg(clearflag ? DONT_MOVE:FORWARD) < 0)
	    issueError("  No more messages !!!", VVSHORT_REPEAT, FQ5_INDX, 
			    BELL_TONE4, 1);
	else {
	    msgfileInfo[msgtype].currentMsgNum++;
	    updateCounterDisplay();
	}
}

/*ARGSUSED*/
void PrevMsg(w, client_data, call_data)
    	Widget w;
	XtPointer client_data; 
	XtPointer call_data;
{
	if (clearflag) {
	    if (displayAnotherMsg(DONT_MOVE) < 0)
		issueError("  There ain't (if U will excuse me) none left !!!", VVSHORT_REPEAT, FQ5_INDX, BELL_TONE4, 1);
	    clearflag = 0;
	    return;
	}

	if (!msgfileInfo[msgtype].numMsg) {
	    issueError("  There are no messages !!!", VVSHORT_REPEAT, FQ5_INDX, BELL_TONE4, 1);
	    return;
	}

	if (msgfileInfo[msgtype].fd <= 0 || msgfileInfo[msgtype].currentMsgNum <= 1) {
	    issueError("  This is the first message !!!", VVSHORT_REPEAT, FQ5_INDX, 
			    BELL_TONE4, 2);
	    return;
	}

	if (displayAnotherMsg(clearflag ? DONT_MOVE:BACKWARD) < 0)
	    issueError("  No more messages !!!", VVSHORT_REPEAT, FQ5_INDX, 
			    BELL_TONE4, 1);
	else {
	    msgfileInfo[msgtype].currentMsgNum--;
	    updateCounterDisplay();
	}
}

int	displayAnotherMsg(dir)
	int dir;
{
	int cc;
	int i;
        XawTextBlock text;
	static MESSAGE_REC msg;
	static char buf[MAX_MSGBUF * 2];
	static int msglen = sizeof(MESSAGE_REC);
	extern struct tm *localtime();

	if (dir == DONT_MOVE)
	    i = msgfileInfo[msgtype].currentFilePos;
	else if (dir == FORWARD)
	    i = msgfileInfo[msgtype].currentFilePos + 1;
        else
	    i = msgfileInfo[msgtype].currentFilePos - 1;

	for (; i >= 0; (dir == FORWARD || dir == DONT_MOVE) ? i++:i--)
	    if ((cc = lseek(msgfileInfo[msgtype].fd, (i * smglen), L_SET)) >= 0) {
	        if (read(msgfileInfo[msgtype].fd, (char *)&msg, smglen) > 0) {
                    if (msg.status == VALID) {
		        text.firstPos = 0;
                        text.length = 0;
                        text.ptr = (char *)0;
		        (void)XawTextReplace(username_w, 0, MAX_MSGBUF , &text);
		        (void)XawTextReplace(msg_w, 0, MESSAGE_LENGTH , &text);

			if (!messageOutActive) {
			    int k;
			    char *sp;
			    struct tm *t;
			    struct hostent *hp;

			    hp = gethostbyaddr(&msg.address, sizeof(struct in_addr), AF_INET);
			    if (hp == (struct hostent *)0)
				sp = "(Unknown Machine)";
		 	    else
				sp = hp->h_name;
			    t = localtime(&msg.time.tv_sec);
			    sprintf(buf, "%-s@%-s  %02d:%02d:%02d  %2d/%02d/%04d", msg.u_name, sp, 
				    t->tm_hour, t->tm_min, t->tm_sec, t->tm_mon + 1, t->tm_mday, 
				    t->tm_year + 1900);
			    text.length = strlen(buf);
			    text.ptr = buf;
			}
			else {
			    text.length = strlen(msg.u_name);
			    text.ptr = msg.u_name;
			}
		        (void)XawTextReplace(username_w, 0, 0, &text);
		        XawTextSetInsertionPoint(username_w, text.length);

		        text.ptr = msg.line;
		        text.length = strlen(msg.line);
		        (void)XawTextReplace(msg_w, 0, 0, &text);
		        XawTextSetInsertionPoint(msg_w, text.length);
			msgfileInfo[msgtype].currentFilePos = i;
		        return (i);
	            }
		}
                else break;
	   }
	   else 
	       break;
	return (-1);
}

int	checkForMessages(mflag)
	int mflag;
{
	int fd, i;
	MESSAGE_REC msg;
	int msglen = sizeof(MESSAGE_REC);

	messageInCounter = messageOutCounter = 0;

	if ((fd = open(MESSAGE_IN, O_RDONLY, 066)) > -1) {
	    for (i = 0; read(fd, (char *)&msg, msglen) > 0; i++)
		 if (msg.status == VALID)
		     messageInCounter++;
	    close(fd);
	}

	if ((fd = open(MESSAGE_OUT, O_RDONLY, 066)) > -1) {
	    for (i = 0; read(fd, (char *)&msg, msglen) > 0; i++)
		 if (msg.status == VALID)
		     messageOutCounter++;
	    close(fd);
	}

	if (!mflag) return(messageInCounter);

	clearflag = 0;
	msgfileInfo[0].numMsg = messageOutCounter;
	msgfileInfo[0].currentMsgNum = 0;
	msgfileInfo[0].currentFilePos = 0;
	msgfileInfo[1].numMsg = messageInCounter;
	msgfileInfo[1].currentMsgNum = 0;
	msgfileInfo[1].currentFilePos = 0;

/*
	if (messageInCounter) 
	    XtSetSensitive(retrievemsg_w, True);
*/
}

int	removeFromMenu(id, buf)
	int id;
	char buf[];
{
	register int i;

	for (i = 0; i < MAX_QUE_CALLS; i++)
	     if (calls[i].id == id) {
		 sprintf(buf, "line%02d", i);
	         XtDestroyWidget(XtNameToWidget(callmenu_w, buf));
	         sprintf(buf, "%-s%2d", calls[i].name, id);
	         XtDestroyWidget(XtNameToWidget(callmenu_w, buf));
		 callwaiting--;
		 calls[i].id = -1;
		 sprintf(buf, "  Lost one !!!  <>  %-s@%-s hung up !!!", calls[i].name, calls[i].address);
		 if (!callwaiting)
		     XtSetSensitive(pickcall_w, False);
		 return (0);
	     }
	     sprintf(buf, "Sub-program is complaining about a call on hold !!!");
}

int	addToMenu(id)
	int   id;
{
	int i;
	struct tm *t;
	static Widget w;
	struct timeval ct;
	static char buf0[MAX_MSGBUF];
	extern struct tm *localtime();
	static char buf2[Little_BufSize], buf1[Little_BufSize];
	
	gettimeofday(&ct, (struct timezone *)0);
	t = localtime(&ct.tv_sec);

	sprintf(buf0, "%02d:%02d  %-s@%-s", t->tm_hour, t->tm_min, hisNameBuf, hisAddressBuf);
	for (i = 0; i < MAX_QUE_CALLS; i++)
	  if (calls[i].id < 0) {
	     calls[i].id = id;
	     strcpy(calls[i].name, hisNameBuf);
	     strcpy(calls[i].address, hisAddressBuf);

	     sprintf(buf1, "line%02d", i);
	     (void) XtVaCreateManagedWidget(buf1, smeLineObjectClass, callmenu_w, NULL);

	     sprintf(buf2, "%-s%2d", calls[i].name, id);
	     w = XtVaCreateManagedWidget(buf2, smeBSBObjectClass, callmenu_w,
					 XtNlabel, buf0,
					 NULL);
	     XtAddCallback(w, XtNcallback, Pick_call, i);
	     break;
          }
	callwaiting++;
}

/*ARGSUSED*/
static
void Pick_call(w, client_data, call_data)
	Widget  w;
	XtPointer client_data; 
	XtPointer call_data;
{
	LOCAL_MSG lmsg;
	int id = (int)client_data;
	static char tempbuf[Little_BufSize];

	lmsg.id = id;
	calls[id].id = -1;

	strcpy(hisNameBuf, calls[id].name); 
	strcpy(hisAddressBuf, calls[id].address);
	XtDestroyWidget(w);

	sprintf(tempbuf, "line%02d", id);
	XtDestroyWidget(XtNameToWidget(callmenu_w, tempbuf));

	XtSetSensitive(pickcall_w, False);
	callwaiting--;
	xrelay_msg(&lmsg, ACCEPT_CALL);
}

/*ARGSUSED*/
void hangUp(w, client_data, call_data)
    	Widget w;
	XtPointer client_data; 
	XtPointer call_data;
{
	extern Widget dial_w;

	msgAnnouncer = False;

	(void)kill(childpid, SIGUSR1);
	if (callwaiting)
	    XtSetSensitive(pickcall_w, True);
	XtSetSensitive(typing_w, True);
	XtSetSensitive(dial_w, True);
/*
	    XtOverrideTranslations(typing_w, typingTrans);
*/
	XtSetSensitive(hangup_w, False);
	XtSetSensitive(accept_w, False);
	clear_textwin(typing_w);
}

void	xsigpipe_handler()
{
	signal(SIGPIPE, (void (*)())xsigpipe_handler);
}
